package PersonalStructure;
import defaultpackage.Structure;

public class ChainedList implements Structure {
	protected Link head;
	protected Cursor cursor;
	public int nbVal = 0;
//	
//	public ChainedList(Link head, Cursor cursor) {
//		this.head = head;
//		this.cursor = cursor;
//		this.nbVal = 1;
//	}

	public ChainedList(Cursor cursor) {
		this.cursor = cursor;
		this.nbVal = 0;

	}
	

	
	public void setNextLink(Link currentLink)
	{
		Link last_next = this.cursor.currentLink.next;
		this.cursor.currentLink.next = currentLink;
		nbVal+=1;
	}
	
	public void setPreviousLink(Link currentLink)
	{
		Link last_next = this.cursor.currentLink.next;
		this.cursor.currentLink.next = currentLink;
		nbVal+=1;
	}
	
	public Link getLink()
	{
		return this.cursor.currentLink;
	}
	
	public Link getNextLink()
	{
		return this.cursor.currentLink.next;
	}
	
	public Link getPreviousLink(Link currentLink)
	{
		return this.cursor.currentLink.next;
	}
	
	public void replaceCursor(int position)
	{

		this.cursor.currentList = this;
		this.cursor.position(position);

	}
	
	public boolean isEmpty() {
		boolean res = false;
		if(this.nbVal != 0)
			res = true;
		return res;
	}

	@Override
	public void Add(int value) {

		if (nbVal == 0) {
			
			Link new_link = new Link(value);
			this.head = new_link;
			this.head.last = new_link;

			this.cursor.currentLink = new_link;

			this.head.next = new_link;
		}
		else {

			
			this.replaceCursor(this.nbVal);
		
			Link last_before_added = this.cursor.currentLink.last;
			Link next_after_added = this.head;
		
			Link new_link = new Link(value, next_after_added, last_before_added);

			last_before_added.next = new_link;
			this.head.last = new_link;
		
			this.cursor.currentLink = new_link;
		}
		this.nbVal += 1;

	}
	
	public int GetNbVal()
	{
		return this.nbVal;
	}

	@Override
	public void RemoveTete() throws Exception  {

		
		this.replaceCursor(nbVal - 1);
		Link last_of_remove = this.cursor.currentLink.last;
		Link next_of_remove = this.cursor.currentLink.next;
		
		last_of_remove.next = next_of_remove;
		next_of_remove.last = last_of_remove;
		
		this.cursor.currentLink = next_of_remove;
	}

	@Override
	public int Get(int index) throws Exception {
		if ((index < 0) && isEmpty())
			throw new IndexOutOfBoundsException("Wrong position");
		this.replaceCursor(index);
		return this.cursor.currentLink.value;
	}



	@Override
	public void RemoveMiddle() throws Exception 
	{
		if(nbVal%2==0)
		{
			// TODO Auto-generated method stub
			this.replaceCursor(nbVal / 2);
			Link last_of_remove = this.cursor.currentLink.last;
			Link next_of_remove = this.cursor.currentLink.next;
			
			last_of_remove.next = next_of_remove;
			next_of_remove.last = last_of_remove;
			
			this.cursor.currentLink = next_of_remove;
		}
		else 
		{
			// TODO Auto-generated method stub
			this.replaceCursor((nbVal-1) / 2);
			Link last_of_remove = this.cursor.currentLink.last;
			Link next_of_remove = this.cursor.currentLink.next;
						
			last_of_remove.next = next_of_remove;
			next_of_remove.last = last_of_remove;
						
			this.cursor.currentLink = next_of_remove;
		}
	}



	@Override
	public int GetLenght() {
		// TODO Auto-generated method stub
		return nbVal;
	}




	@Override
	public int GetStandard(int x) {
		int res = -1;
		if (x != 0)
			res = this.GetStandard(x-1);
		else
			res = this.cursor.currentLink.value;
			
		return res;	
	}



	@Override
	public int GetDichotomous(int x) {
		int i = this.GetLenght();
		int res = -1;
		while (x != i)
		{
			if (x > i)
				i = i+i/2;
			else
				i = i/2;
		}
		try {
			res = this.Get(i);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return res;
	}
}
